//***************************************************************************************
// BMP280/BME280 Pressure Sensor
// Do I2C bit banger
// Uses 1 MHz DCO
// Jed Margolin  11/20/2021.
//***************************************************************************************
// I2C Interface
// These need to be initialized in Main
#define SCL_POUT  P1OUT
#define SCL_BIT   BIT5

#define SDA_POUT  P1OUT
#define SDA_PIN   P1IN
#define SDA_PDIR  P1DIR
#define SDA_BIT   BIT7
//=======================================
#define IIC_ID_WRITE 0xEC    // (0x76<<1)        BMP280 device
#define IIC_ID_READ 0xED     // (0x76<<1 & 0x01

#define hum_lsb 0xFE;       // humidity byte 0      Read Only  bmpdata[7]
#define hum_msb 0xFD;       // humidity byte 1      Read Only  bmpdata[6]
#define temp_xlsb 0xFC;     // temperature byte 0   Read Only  bmpdata[5]   R,Address,Data
#define temp_lsb 0xFB;      // temperature byte 1   Read Only  bmpdata[4]
#define temp_msb 0xFA;      // temperature byte 2   Read Only  bmpdata[3]
#define press_xlsb 0xF9;    // pressure byte 0      Read Only  bmpdata[2]
#define press_lsb 0xF8;     // pressure byte 1      Read Only  bmpdata[1]
#define press_msb 0xF7;     // pressure byte 2      Read Only  bmpdata[0]

#define bme_config 0xF5;    // configuration        Read/Write  R/W,Address;Data
#define bme_ctrl_meas 0xF4; // control measurement  Read/Write  R/W,Address;Data
#define bme_status 0xF3;    // status               Read Only
#define bme_reset 0xE0;     // reset                Write Only  /W,Address;Data
#define bme_id 0xD0;        // part id = 0x58       Read Only

unsigned char i2c_read(unsigned char);
void i2c_stop_bit(void);
void i2c_start_bit(void);
unsigned char i2c_sendbyte(unsigned char);
unsigned char i2c_getbyte(void);
unsigned char i2c_write(unsigned char, unsigned char);

void bme_init(void);
void getcal(void);
int wait_ready(void);
void bme_readburst_cal(void);

void wait(int);
void wait1(void);
void wait5ms(void);

// Globals
unsigned char i2c_rxdata;
unsigned char intflag, intcount;

unsigned char bmedata[8];
unsigned char caldata[24];      // bme calibration data dig T1 -T3, dig P1 - P9, dighum
unsigned char humdata[8];

long signed int bme280_compensate_T(void);

unsigned short dig_T1, dig_P1;
long int dig_T2, dig_T3, dig_P2, dig_P3, dig_P4, dig_P5, dig_P6, dig_P7, dig_P8, dig_P9;
unsigned char dig_H1, dig_H3;
int dig_H2, dig_H4, dig_H5;
char dig_H6;
//unsigned long int adc_p, adc_t, adc_h, adc_temp;
signed long int adc_p, adc_t, adc_h, adc_temp;
unsigned char device_id;

int do_compensation(void);    // do compensation for temperature and pressure
int do_compensation_test(void);
void read_bme280(void);

long T, F, hextemp;
unsigned long Humidity, Humidity3;
unsigned long p;
unsigned long show_temperature, show_humidity;
//================================================
